package infosys;

/** This is a special class for checking out freight.
 *  The CheckOutLogic class is responsible for processing this task.
 */
public class CheckOutTask extends Task {

  /** The catalog name of the freight. */
  protected String freightName;

  /** The amount to check out. */
  protected long amount;

  /** Constructs a new CheckOutTask.
   *  @param freightName The catalog name of the freight.
   *  @param amount The amount to check out.
   */
  public CheckOutTask (Object source, String freightName, long amount) {
    this.source = source;
    this.freightName = freightName;
    this.amount = amount;
  }

  /** Returns the catalog name of the freight.
   *  @return The catalog name of the freight.
   */
  public String getFreightName() {
    return this.freightName;
  }

  /** Returns the amount to check out.
   *  @return The amount to check out.
   */
  public long getAmount() {
    return this.amount;
  }

  public String toString() {
    return "Check out: " + amount + " " + freightName;
  }


}// end of class.