package infosys;

/** A TaskListener can be added to any Task object.
 *  All TaskListeners are informed of the tasks state.
 */
public interface TaskListener {

  /** Invoked when a Task was scheduled. */
  public void taskScheduled(TaskEvent te);

  /** Invoked when a Task is processed. */
  public void taskProcessed(TaskEvent te);

  /** Invoked when a Task has terminated. */
  public void taskTerminated(TaskEvent te);

  /** Invoked when a Task was interrupted or entered an
   *  exceptional state.
   */
  public void taskInterrupted(TaskExceptionEvent tee);

}// end of interface.