package infosys;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

public class UnitGUI extends JFrame implements TaskListener {
    JPanel contentPane = null;
    CheckInGUI checkIn   = new CheckInGUI();
    CheckOutGUI checkOut = new CheckOutGUI();
    GridLayout gridLayout1 = new GridLayout(3,1);
    Control.Unit unit = null;
    JTextArea txtInfo = new JTextArea();
    JScrollPane scrTxtInfo = new JScrollPane(txtInfo);

    public UnitGUI(Control.Unit unit) {
        try {
            this.unit = unit;
            jbInit();
        }
        catch(Exception e) {
            e.printStackTrace();
        }
    }

    private void jbInit() throws Exception {
        contentPane = (JPanel) this.getContentPane();
        contentPane.setLayout(gridLayout1);
        checkOut.setMinimumSize(new Dimension(0, 0));
        checkOut.setPreferredSize(new Dimension(0, 0));
        contentPane.setPreferredSize(new Dimension(300, 396));
        this.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
        this.setTitle(unit.name);
        unit.addTaskListener(this);
        if ((unit.type & Control.Unit.TYPE_CHECK_IN)  != 0) {
            contentPane.add(checkIn, null);
            checkIn.cmbCatalogName.setModel(unit.getControl().getCatalogModel());
            checkIn.butCheckIn.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    checkIn_actionPerformed(e);
                }
            });
        }
        if ((unit.type & Control.Unit.TYPE_CHECK_OUT) != 0) {
            contentPane.add(checkOut, null);
            checkOut.cmbCatalogName.setModel(unit.getControl().getCatalogModel());
            checkOut.butCheckOut.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    checkOut_actionPerformed(e);
                }
            });
        }
        pack();
        contentPane.add(scrTxtInfo, null);
    }

    /**Overridden so we can exit when window is closed*/
    protected void processWindowEvent(WindowEvent e) {
        super.processWindowEvent(e);
        if (e.getID() == WindowEvent.WINDOW_CLOSING) {

        }
    }

    public static java.sql.Date parseDate(String date) {
        int year = 0;
        int month = 0;
        int day = 0;
        day   = Integer.parseInt(date.substring(0,2));
        month = Integer.parseInt(date.substring(3,5)) - 1;
        year  = Integer.parseInt(date.substring(6,date.length()));

        java.util.Calendar c = java.util.Calendar.getInstance();
        c.set(year,month,day);
        return new java.sql.Date(c.getTime().getTime());
    }

    void checkIn_actionPerformed(ActionEvent e) {
        /** @todo add the edited catalogentry to the model. */
        String        catalog;
        int           amount;
        java.sql.Date expiration = null;
        try {
            catalog    = (String) checkIn.cmbCatalogName.getSelectedItem();
            amount     = Integer.parseInt(checkIn.txtAmount.getText());
            expiration = parseDate(checkIn.txtExpiration.getText());

            Task t = unit.checkIn(catalog, amount, expiration);

        } catch (Exception ex) {
            JOptionPane.showMessageDialog(this,"Cannot process check in request. Data failure.\n Check input data!", "Check in failure",JOptionPane.ERROR_MESSAGE);
        }
    }

    void checkOut_actionPerformed(ActionEvent e) {
        /** @todo add the edited catalogentry to the model. */
        String        catalog;
        int           amount;
        try {
            catalog    = (String) checkOut.cmbCatalogName.getSelectedItem();
            amount     = Integer.parseInt(checkOut.txtAmount.getText());

            Task t = unit.checkOut(catalog, amount);

        } catch (Exception ex) {
            JOptionPane.showMessageDialog(this,"Cannot process check in request. Data failure.\n Check input data!", "Check in failure",JOptionPane.ERROR_MESSAGE);
        }
    }


    public void taskScheduled(TaskEvent te) {
        txtInfo.append("task scheduled : " + te.getSource() + "\n");
    }
    public void taskProcessed(TaskEvent te) {
        txtInfo.append("task processing: " + te.getSource() +" > "+ te.getMessage()+"\n");
    }
    public void taskTerminated(TaskEvent te) {
        txtInfo.append("task terminated: " + te.getSource() + "\n");
    }
    public void taskInterrupted(TaskExceptionEvent tee) {
        txtInfo.append("\ntask failed    : " + tee.getSource() +
                       "\n     reason    : " + tee.getMessage() + "\n");
    }

}